//+------------------------------------------------------------------+
//|                                                     Donny_01.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double slmarg=100;
extern double tpmarg=100;
extern int MinimumRange=200;
extern double FiboLevel=0.382;
extern double lots=1;

#define slipage 5
#define spread 2

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int GetOrderByModeCount(int mode)
{
   int ix,count=0;
   
   for(ix=0; ix<OrdersTotal(); ix++)
   {
      if(OrderSelect(ix,SELECT_BY_POS)==false) continue;
      if(OrderType()==mode) count++;
   }
   
   return(count);
}  

void OpenSell()
{
   double sl,tp;
   if (slmarg>0)
      sl=(Bid+slmarg*Point);
   else
      sl=0;
      
   if (tpmarg>0)
      tp=(Bid-tpmarg*Point);
   else 
      tp=0;

   OrderSend(Symbol(),OP_SELL,lots,Bid,3,sl,tp,"Daemon",0,0,Green);
}

void OpenBuy()
{
   double sl,tp;
   
   if (slmarg>0)
      sl=(Ask-slmarg*Point);
   else
      sl=0;
      
   if (tpmarg>0)
      tp=(Ask+tpmarg*Point);
   else 
      tp=0;
   
   OrderSend(Symbol(),OP_BUY,lots,Ask,3,sl,tp,"Daemon",0,0,Green);
}


int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
  
datetime oldtime;
double trigger_level;
double range;
bool buy_or_sell;
bool yesterday_more_than_minrange;
bool hari_ini_sudah;
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
      if (Time[0]!=oldtime)
      {
         range=MathAbs(High[1]-Low[1]);

         if (range/Point >=MinimumRange)
            yesterday_more_than_minrange=true;
         else 
            yesterday_more_than_minrange=false;

         if (Close[1]<Open[1]) 
            buy_or_sell=false;
         else     
            buy_or_sell=true;
            
         if (buy_or_sell)
            trigger_level=High[1]-FiboLevel*range;
         else
            trigger_level=Low[1]+FiboLevel*range;
            
         hari_ini_sudah=false;         
         oldtime=Time[0];   
      }

      if (yesterday_more_than_minrange && !hari_ini_sudah)
      {
         if (buy_or_sell && GetOrderByModeCount(OP_BUY)==0)
         {
            if (Ask < trigger_level)
            {
               OpenBuy();   
               hari_ini_sudah=true;  
            }               
         }
         
         if (!buy_or_sell && GetOrderByModeCount(OP_SELL)==0)
         {
            if (Bid > trigger_level)
            {
               OpenSell();
               hari_ini_sudah=true;  
            }               

         }
      }      

   return(0);
  }
//+-----------------------------------------------------------------+